import pygame as p

class AnimatedSprite(p.sprite.Sprite):
    """A not so exotic class that gives sprites animation"""
    def __init__(self,imgs):
        p.sprite.Sprite.__init__(self)
        self.img_arrayf=imgs
        self.rect=imgs[0].get_rect()
        self.current_frame=0
        self.length=len(self.img_arrayf)-1
        self.direction=0
        self.img_arrayb=[]
        
        for surface in self.img_arrayf:
            self.img_arrayb.append(p.transform.flip(surface,True,False))
        
    def next_frame(self):
        """replace the current image with the next frame"""
        self.current_frame+=1
        if(self.current_frame > self.length or self.current_frame <0):
            self.current_frame=0
        if(self.direction==0):
            self.image=self.img_arrayf[self.current_frame]
        if(self.direction==1):
            self.image=self.img_arrayb[self.current_frame]


def loadanim(file,width):
    """Loads an animation from a file"""
    image=p.image.load(file).convert()
    tmpimg=[]
    tmp=p.surface.Surface((width,image.get_height()))
    rect=p.rect.Rect(0,0,width,image.get_height())
    for n in range(0,image.get_width()/width):
        rect.left=width*n
        tmp.blit(image,(0,0),rect)
        tmp.set_colorkey((123,123,123))
        tmpimg.append(tmp.copy())
    return tmpimg
        
        
