#this file provides what you need to build a cutscene well any automated thing
import charactor as c
import pygame as p
import text as t
import animation as a

class background(p.sprite.Sprite):
    def __init__(self,file,screen):#you better load something with an apporpriate size!
        p.sprite.Sprite.__init__(self)
        self.image=p.transform.scale(p.image.load(file).convert(),(screen.get_width(),screen.get_height()))
        self.rect=self.image.get_rect()
        self.rect.top=0
        self.rect.left=0
      
class actor(c.Charactor):
    """automated things that walk"""
    def __init__(self,moving,still,startx,starty,speed,level,font):
        tmpimg=p.image.load(still)
        tmpmoving=a.loadanim(moving,tmpimg.get_width())
        c.Charactor.__init__(self,tmpimg, tmpmoving,startx,starty)
        self.speed=speed
        self.c=0
        self.targetx=startx
        self.targety=starty
        self.txtdata=text("",font,0,0,0,(255,255,255),False)    
        

    def say(self,what,level,cycles=0):
        level.text_group.remove(self.txtdata)
        ret=False
        if(cycles==0):
            ret=True
            cycles=level.cycles(len(what)*150)
        self.txtdata.retime(cycles)
        self.txtdata.render_text(what)
        self.txtdata.relocate(self.rect.centerx-(self.txtdata.image.get_width()/2),self.rect.top-10-(self.txtdata.image.get_height()))
        level.add_text(self.txtdata)
        if(ret==True):
            return len(what)*150 #gives you the time, if you didn't supply one yourself

    def relocate(self,x,y):
        self.rect.left=x
        self.rect.top=y

    def walk_to(self,x,y,cycles):
        """makes character walk to position x,y in time"""
        self.speedx=(x-self.rect.left)/cycles
        self.speedy=(y-self.rect.top)/cycles
        self.rect.top+=y-((self.speedy*cycles)+self.rect.top)
        self.rect.left+=x-((self.speedx*cycles)+self.rect.left)
        
        self.targetx=x
        self.targety=y
        
        self.moving=True
    def update(self):
        if(self.speedx>0 and self.direction==1):
            self.direction=0
        if(self.speedx<0 and self.direction==0):
            self.direction=1
        
        self.c+=self.speed
        if(self.c>1):
            self.update_graphics()
            self.c=0
        
        if(self.moving==True):
            self.rect.left+=self.speedx
            self.rect.top+=self.speedy
        if(self.targetx == self.rect.left and self.targety == self.rect.top):
            self.moving=False
            
        
class text(t.TextObject):
    """Text widget for use in cutscenes"""
    def __init__(self,text,font,x,y,cycles,color,antialias):
        t.TextObject.__init__(self,text,font,x,y,color,antialias)
        self.passed=0
        self.max=cycles

    def relocate(self,x,y):
        self.rect.left=x
        self.rect.top=y
    
    def retime(self,maximum):
        self.max=maximum
        self.passed=0

    def update(self,group):
        if(self.max!=0):
            self.passed+=1
            if(self.passed>self.max):
                group.remove(self) #will become invisible

class CutScene: #no it's NOT EMO, it doesn't cut itself, in fact it doesn't really cut "it" at all!
    """This will provide all of the stuff you really don't want to care about when you design a cut scene (event handling, clock and so on)"""
    def __init__(self,screen,desired_fps):
        self.screen=screen
        self.running=True
        self.Clock=p.time.Clock()
        self.fps=desired_fps
        self.time=0
        self.timemarks=[]

        self.text_group=p.sprite.Group()
        self.actor_group=p.sprite.Group()
        self.bg_group=p.sprite.Group() #should use RenderUpdates on the other groups instead!


    def end(self):
        self.running=False

    def cycles(self,time): #this will fuck up if framerate isn't what it's supposed to be
        return (time*self.fps)/1000

    def time_is(self,time):
        """makes sure a certain action happens at a certain time and only once"""
        if(self.time>=time and time not in self.timemarks):
            self.timemarks.append(time)
            return True
        return False
    def set_bg(self,bg):
        self.bg_group.empty()
        self.bg_group.add(bg)
    def add_character(self,who):
        self.actor_group.add(who)

    def remove_character(self,who):
        self.actor_group.remove(who)

    def add_text(self, which):
        self.text_group.add(which)

    def updater(self):
        self.text_group.update(self.text_group)
        self.actor_group.update()

    def painter(self):
        self.actor_group.draw(self.screen)
        self.text_group.draw(self.screen)
    
    def tick(self):
        
        self.Clock.tick(self.fps)
        self.time+=self.Clock.get_time()

    def put_bg(self): #this little guy is temporary!
        self.bg_group.draw(self.screen)
        
    def flip(self):
        p.display.flip()
    
    def eventHandler(self):
        for event in p.event.get():
            if(event.type==p.KEYDOWN):
                if(event.key==p.K_ESCAPE or event.key==p.K_SPACE):
                    self.running=False
            if(event.type==p.QUIT):
                p.quit() #not a good solution but hey! It works!
            
    def AutomatedStuff(self):
        self.tick()
        self.put_bg()
        self.eventHandler()
        self.updater()
        self.painter()
        self.flip()

