#This will be used to simplify the programming of levels

import pygame as p
import text as t
import charactor as c
import animation as a
from cutscene import text
from cutscene import background
import god_bar as g



class trigger(p.sprite.Sprite): #doesn't really have an image or anything, but sprites can be grouped easily!
    """if you walk on one of theese, it will do something"""
    def __init__(self,x,y,width,height,suicidal=False): #suicidal once disappear when they are used
        p.sprite.Sprite.__init__(self)
        
        self.rect=p.rect.Rect(x,y,width,height)
        
        self.suicidal=suicidal
    
    def group_on(self,group,Kill=False):
        return p.sprite.spritecollide(self,group,Kill)
    def single_on(self,other):
        return p.sprite.collide_rect(self,other)        
        

class invisible_wall(p.sprite.Sprite):
    def __init__(self,x,y,width,height):
        p.sprite.Sprite.__init__(self)
        self.rect=p.rect.Rect(x,y,width,height)
    def draw(self,screen):
        pass
    def update(self):
        pass

class solid(p.sprite.Sprite):
    """The foundation of anything that sits anywhere, andwhich can't be walked upon and which is impossible to move"""
    def __init__(self,x,y,surface):
        p.sprite.Sprite.__init__(self)
        self.image=surface.copy() #this will become the standard for all objects in the future
        self.rect=self.image.get_rect()
        self.rect.left=x
        self.rect.top=y
        
    def hide(self, group): #just in case an event would need to pretend that the solid didnt exist for a moment
        group.remove(self)
    def show(self, group):
        group.add(self)
    
    def update(self):
        
        pass #Hey, they don't really do anything!

class living_thing(c.Charactor):
    """will represent a general character in the game!"""
    def __init__(self,still,moving,x,y,rate):
        tmpimg=p.image.load(still)
        tmpmoving=a.loadanim(moving,tmpimg.get_width())
        c.Charactor.__init__(self,tmpimg,tmpmoving,x,y)
        self.c=0.0
        self.rate=rate
            
    def set_speed(self,speedx,speedy):
        self.speedx=speedx
        self.speedy=speedy
          
    def teleport(self,x,y):
        self.rect.x=x
        self.rect.y=x

    def collidex(self,group):
        tmp=p.sprite.spritecollide(self,group,False)
        for object in tmp:
            if(object!=self):
                if(self.speedx>0):
                    self.rect.right=object.rect.left-1
                if(self.speedx<0):
                    self.rect.left=object.rect.right+1
    def collidey(self,group):
        tmp=p.sprite.spritecollide(self,group,False)
        
        for object in tmp:
            if(object!=self):
                if(self.speedy>0):
                    self.rect.bottom=object.rect.top-1
                if(self.speedy<0):
                    self.rect.top=object.rect.bottom+1

    
class player(living_thing):
    """The player"""
    def __init__(self,still,moving,x,y,rate):
        living_thing.__init__(self,still,moving,x,y,rate)
        #it really doesn't do anything, appart from adding a few funtions
        #and the fact that it is much easier to understand what the player class does
        #than it is to understand what the "living_thing" class does
    
    def update(self,baddies,solids):
        if((self.speedx!=0 or self.speedy!=0) and self.moving==False):
            self.moving=True
        if(self.speedx==0 and self.speedy==0 and self.moving == True):
            self.moving=False
        if(self.speedx>0 and self.direction==1):
            self.direction=0
        if(self.speedx<0 and self.direction==0):
            self.direction=1
        self.c+=self.rate
        if(self.c>1.0):
            self.c=0.0
            self.update_graphics()
        
        self.rect.left+=self.speedx
        self.collidex(solids)
        if(self.rect.right>640):
            self.rect.right=638
        if(self.rect.left<0):
            self.rect.left=1
        self.rect.top+=self.speedy
        self.collidey(solids)
        if(self.rect.top<0):
            self.rect.top=1
        if(self.rect.bottom>480):
            self.rect.bottom=477

        if(not p.sprite.spritecollideany(self,baddies)):
            return 1 #praise the lord
        return 0 #sux
    def draw(self,screen):
        screen.blit(self.image,self.rect)
        


class baddie(living_thing):
    """NPC's that attack if you come close enough, or if a trigger mechanism makes em rush at you!""" 
    def __init__(self,x,y,sleeping,running,rate,radius): #for now, I'm still passing file names! But it _Will_ change!
        living_thing.__init__(self,sleeping,running,x,y,rate)
        self.radius=radius
        #if moving is false, he is actually sleeping, so there wont' be a sleeping thingy
    def sleep(self):
        self.moving=False
    def wake(self):
        self.moving=True
    
    def set_speeds(self,player):
        if(self.rect.left>player.rect.left):
            self.speedx=-3
        if(self.rect.left<player.rect.left):
            self.speedx=3
        if(self.rect.top>player.rect.top):
            self.speedy=-3
        if(self.rect.top<player.rect.top):
            self.speedy=3

        if(self.rect.top==player.rect.top):
            self.speedy=0
        if(self.rect.left==player.rect.top):
            self.speedx=0
        

    def update(self, player, solids,baddies):
        if(p.sprite.collide_circle(self,player)):
               self.wake() #oops he found ya!
        if(self.moving==True):
            if(self.speedx>0 and self.direction == 1):
                self.direction=0
            if(self.speedx<0 and self.direction ==0):
                self.direction=1
        
        self.c+=self.rate
        if(self.c>=1.0):
            self.c=0.0
            self.update_graphics()
            self.set_speeds(player) #tells baddie where the player is hiding
        if(self.moving==True):
            self.rect.left+=self.speedx
            self.collidex(solids)
            self.collidex(baddies) #I wonder if this will work, he will colide with himself....
            self.rect.top+=self.speedy
            self.collidey(solids)
            self.collidey(baddies)


class LevelHandler:
    """This will take care of the boring stuff
    you don't want to care about when designing levels"""
    def __init__(self,screen,desired_fps,winnable=True):
        self.godbar=g.godbar()
        self.text=""
        self.godbar_group=p.sprite.GroupSingle(self.godbar)
        self.walkspeed=2
        self.screen=screen
        self.bg=p.sprite.GroupSingle()
        self.Clock=p.time.Clock()
        self.running=True
        self.winnable=winnable
        if(winnable==1):
            self.defeat=True #you have in fact lost until you have won!
        self.fps=desired_fps
        self.time=0
        self.timemarks=[]#much stuff will happen conditionally, but some things are controlled by time!
        
        #Groups of objects
        self.text_group=p.sprite.Group()
        self.player=None #loaded by level designer
        self.baddie_group=p.sprite.Group() #evil things
        self.solid_group=p.sprite.Group() #These guys wont move a cm (Screw Inches! SI-units for the win)
        self.wall_group=p.sprite.Group()
        #theese are invisible, but the group structure is convenient!
        self.event_group=p.sprite.Group()#doesn't handle envents, makes stuff happen when you step on stuff
    

    def stop(self):
        self.running=False
    def set_bg(self,bg):
        self.bg.add(bg) #this is just a surface!
    def add_text(self,text):
        self.text_group.add(text)
    def set_player(self,player):
        self.player=player
    def add_baddie(self,baddie):
        self.baddie_group.add(baddie)
    def add_event(self,event):
        self.event_group.add(event)
    def add_solid(self,solid):
        self.solid_group.add(solid)
        self.wall_group.add(solid)
    def add_wall(self,wall):
        self.wall_group.add(wall)

    def drawer(self): #it doesn't contain stuff, it draws stuff
        self.bg.draw(self.screen)
        self.player.draw(self.screen)
        self.baddie_group.draw(self.screen)
        self.solid_group.draw(self.screen)
        self.text_group.draw(self.screen)
        self.godbar_group.draw(self.screen)

    def updater(self):
        self.event_group.update(self)
        self.text_group.update(self.text_group)
        self.baddie_group.update(self.player,self.wall_group,self.baddie_group)
        if(self.player.update(self.baddie_group,self.wall_group)==0):
            self.stop()#player checks if baddie intercept him, not other way around!
        self.solid_group.update()#they could be animated!
        self.godbar_group.update(self.text)
        

    def eventHandler(self):
        for event in p.event.get():
            if(event.type==p.KEYDOWN):
                if(event.key==p.K_UP):
                    self.player.set_speed(self.player.speedx,(-1)*self.walkspeed)
                if(event.key==p.K_DOWN):
                    self.player.set_speed(self.player.speedx,self.walkspeed)
                if(event.key==p.K_LEFT):
                    self.player.set_speed((-1)*self.walkspeed,self.player.speedy)
                if(event.key==p.K_RIGHT):
                    self.player.set_speed(self.walkspeed,self.player.speedy)
                if(event.key==p.K_ESCAPE):
                    self.stop()
            if(event.type==p.KEYUP):
                if(event.key==p.K_UP or event.key==p.K_DOWN):
                    self.player.set_speed(self.player.speedx,0)
                if(event.key==p.K_LEFT or event.key==p.K_RIGHT):
                    self.player.set_speed(0,self.player.speedy)
            if(event.type==p.QUIT):
                p.quit() #<--- someone will kill me for this one day
    
                    
        
        
        
    def AutomaticStuff(self):
        self.Clock.tick(self.fps)
        self.eventHandler()
        self.updater()
        self.drawer()
        p.display.flip()
