import pygame as p


class TextObject(p.sprite.Sprite):
    """A Text "widget", so to speak"""
    def __init__(self,text,font,x,y,color,antialias):
        p.sprite.Sprite.__init__(self)
        self.antialias=antialias
        self.font=font
        self.text=text
        self.color=color
        self.rect=p.rect.Rect(x,y,0,0)
        self.image=None
        self.render_text(self.text)
    

    def render_text(self,text):
        """replaces the old text with a new one"""
        tmp=[]
        widest=0
        for tmp_txt in text.splitlines():
            tmp.append(self.font.render(tmp_txt,self.antialias,self.color))
            if(tmp[-1].get_width()>widest):
                widest=tmp[-1].get_width()

        length=len(tmp)
        h=self.font.get_linesize()
        new_pic=p.surface.Surface((widest,h*length)).convert()
        new_pic.fill((123,123,123)) #text must not have this color!
        new_pic.set_colorkey((123,123,123))
        
        for n in range(0,len(tmp)):
            new_pic.blit(tmp[n],(0,h*n))
        
        self.image=new_pic
        self.rect.width=self.image.get_width()
        self.rect.height=self.image.get_height()
